% going over all methods, categories and repeition runs 

load('Split/categoryInfo.mat','categories');
load('Split/Natural/split.mat','negTestImages');
% categories = categories(1:2);
nC = length(categories);
overwrite = true;
%featureConvolution('GaborS1',0.7,overwrite);
%featureConvolution('GaborS1_11',0.4,overwrite);
%featureConvolution('GaborS1_25',1,overwrite);

cd Code
mex Ctransform.c
mex Cmax.c
mex Chistog.c
mex mexc_SharedSketch.cpp
mex mexc_ComputeSUM2.cpp
mex mexc_ComputeMAX1.cpp
mex mexc_Copy.cpp
mex mexc_TemplateAffineTransform.cpp
mex mexc_CropInstance.cpp
cd ..

% natural stat
% tilt_GaborS1



%
% learning
%

for iRun = 11
     %
     % learn a template
     %
     iCat = 1;
     experiment = STF_MT(iRun,iCat,categories);
     experiment.learn_all_category; % calls the class method learn(this) of ActiveBasisLocalNorm 
     clear experiment
end


%
% visualize
%

iRun = 11;
for iter = 1:10

	for iCat = 1:nC
		% collect all templates per category
		category = categories{iCat};
		load(sprintf('Result/%s/STF_MT/model_run%d_iter%d.mat',category,iRun,iter),'list_S2Template','list_S2TemplateTexture');
		nT = length(list_S2Template);
		list_symSketch = {};
		list_symTexture = {};
		for iT = 1:nT

			% render texture and sketch
			list_symSketch{iT} = list_S2Template{iT}.sym;
			sym = list_S2Template{iT}.sym;
			S2TemplateTexture = list_S2TemplateTexture{iT};
			nTextureToDisplay = 30;

				Mx = S2TemplateTexture.selectedRow(1:min(end,nTextureToDisplay)) + 1 + floor(size(sym,1)/2);
				My = S2TemplateTexture.selectedCol(1:min(end,nTextureToDisplay)) + 1 + floor(size(sym,2)/2);
				Mi = S2TemplateTexture.selectedOri(1:min(end,nTextureToDisplay));
				sym = displayGaborTemplate(size(sym), Mx,...
					My,...
				    Mi,...
				    ones(1,length(Mx)) );

			list_symTexture{iT} = double(sym);

		end
		syms_sk = displayImages(list_symSketch,nT,150,150);
		syms_tex = displayImages(list_symTexture,nT,150,150);
		towrite = 255 * ones(size(syms_sk,1),size(syms_sk,2),3);

		towrite(:,:,1) = 0.5 * double(syms_sk);
		towrite(:,:,2) = double(syms_sk);
		towrite(:,:,3) = double(syms_sk);
		towrite(:,:,1) = towrite(:,:,1) + 0.5 * double(syms_tex);
		% towrite(:,:,1) = max(towrite(:,:,1), 0.8* double(syms_tex));
		% towrite(:,:,3) = towrite(:,:,3) + double(syms_tex); % - max(double(syms_tex(:)));
		towrite = uint8(255 * (towrite-min(towrite(:)))/(max(towrite(:))-min(towrite(:))));

		imwrite(towrite,sprintf('Result/%s/STF_MT/syms_run%d_iter%d.png',category,iRun,iter));
	end

end



%
% testing
%

for iRun = 11
     %
     % learn a template
     %
     iCat = 1;
     experiment = STF_MT(iRun,iCat,categories);
     experiment.test_multiclass; % calls the class method learn(this) of ActiveBasisLocalNorm 
     clear experiment
end




%
% post processing by SVM
%

for iRun = 11
    experiment = STF_MT(iRun,1,categories);
    experiment.post_process_svm; 
    clear experiment
end


%
% evaluating (svm result)
%

for iRun = 11
     numImage = 0;
     for iCat = 1:nC
         load(sprintf('Split/%s/split%d.mat',categories{iCat},iRun),'posTestImages');
         pos{iCat} = numImage + (1 : length(posTestImages));
         numImage = numImage + length(posTestImages);
     end
     
     load(sprintf('%s/svmresult_run%d.mat','Result/summary/STF_MT', iRun), 'svm_prediction');
     
     [averageRate confusionMatrix correctRate] = getConfusionMatrix(svm_prediction,pos);

	if ~exist('Result/summary/STF_MT', 'dir')
		mkdir('Result/summary/STF_MT');
	end
	save(sprintf('%s/eval_result_run%d.mat','Result/summary/STF_MT', iRun), 'averageRate', 'confusionMatrix', 'correctRate');
end







